<template>
  <div class="offers">
    <header class="app__header">
      <div class="logo">
        <img class="logo__image" src="../assets/logo.png"/>
      </div>
      <div class="filter">
        <b-input-group>
          <b-form-input v-model="search"
                        size="sm"
                        @keyup.enter.native="loadData()"></b-form-input>
          <b-input-group-append>
            <b-btn variant="success"
                   size="sm"
                   class="material-icons"
                   @click="loadData()">search</b-btn>
          </b-input-group-append>
        </b-input-group>
      </div>
      <div class="action">
        <b-button class="material-icons" size="sm" variant="outline-secondary">settings</b-button>
      </div>
    </header>
    <main class="items">
      <item :items="records"></item>
    </main>
  </div>
</template>

<script>
// @ is an alias to /src
import axios from 'axios'
import item from '@/components/Item.vue'
import getISOWeek from 'date-fns/get_iso_week'
import getYear from 'date-fns/get_year'

export default {
  name: 'home',
  data () {
    return {
      records: [],
      search: ''
    }
  },
  methods: {
    loadData () {
      this.records = []
      const today = new Date()
      const startdate = parseInt(getYear(today).toString() + getISOWeek(today).toString(), 0)

      axios.post('/api/items', { startdate, filter: this.search })
        .then((response) => {
          // handle success
          this.records = response.data
          console.log('found records: ', response.data.length)
        })
        .catch((error) => {
          // handle error
          console.log(error)
        })
    }
  },
  components: {
    item
  },
  created () {
    this.loadData()
  }
}
</script>

<style lang="postcss">
  .offers {
    display: flex;
    flex-direction: column;
    height: 100%;
  }

  .app__header {
    flex: 0 0 auto;
    display: flex;
    flex-direction: row;
    flex-wrap: nowrap;
    justify-content: flex-start;
    align-content: stretch;
    align-items: stretch;
    height: 50px;
    background-color: rgb(255, 255, 255);

    .logo {
      flex: 0 1 auto;
      padding: 5px 24px;

        &__image {
          height: 40px;
        }
    }

    .filter {
      padding: 10px 0;
      flex: 1 1 auto;
    }

    .action {
      flex: 0 1 auto;
      padding: 10px 24px;
    }
  }

  .items {
    flex: 1 1 auto;
    overflow: auto;
    background-color: rgb(228, 228, 228);
  }
</style>
